<template>
  <v-container class="mt-16 pa-16 align-center rounded-lg">
    <v-row>
      <v-col>
          <v-data-table
            dark
            :headers="headers"
            :items="users"
            :options.sync="options"
            :server-items-length="totalRows"
            :footer-props="{
            'items-per-page-options': [20]
          }"
            :search="search"
            class="elevation-5"
          >
            <template v-slot:top>
              <v-toolbar flat>
                <v-toolbar-title>Rick and Morty</v-toolbar-title>
                <v-divider class="mx-4" inset vertical></v-divider>
                <v-spacer></v-spacer>
                <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  <v-spacer></v-spacer>
                  <AddEditItem/>
                  <DeleteItem/>
                  <Profile/>
              </v-toolbar>
            </template>
            <template v-slot:item.actions="{ item }">
              <ListActions :item="item" />
            </template>
            <template v-slot:no-data>
              <v-btn color="primary" @click="initialize"> Reset </v-btn>
            </template>
          </v-data-table>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapActions,mapState} from "vuex"
import AddEditItem from "./dialogs/addEditItem"
import DeleteItem from "./dialogs/deleteItem"
import ListActions from "./actions/listActions"
import Profile from "./dialogs/profile"
export default {
  components: {
    AddEditItem,
    DeleteItem,
    ListActions,
    Profile
  },
  name: "List",
  data: () => ({
    search: "",
    totalRows: 0,
    options:{},
    headers: [],
  }),
  computed: {
    ...mapState({
      users: state => state.users,
    }),
  },
  methods: {
    ...mapActions(["SET_USERS"]),
    async getCharacters(){
      const response = await this.SET_USERS({name: this.search, ...this.options})
      this.headers = response.headers
      this.totalRows = response.total
    }
  },
  watch: {
      options:{
        async handler(){
          console.log("this is the options :",JSON.stringify(this.options))
          this.getCharacters()
        },
        deep: true,
    },
    async search(){
      if (!this.writing) {
        setTimeout(() => {
          this.getCharacters()
          this.writing = false
        }, 1000)
        this.writing = true
      }
    }
  }
};
</script>
